import { Entity } from "./ECS/entityMgr";
import { ComponentSystem } from "./ECS/component";
export declare class Camera {
    entity: Entity;
    name: String;
    projection: Float32Array;
    view: Float32Array;
    vp: Float32Array;
    fov: number;
    aspect: number;
    near: number;
    far: number;
    up: Float32Array;
    lookAt: Float32Array;
    isDirty: boolean;
    constructor(aspect?: number, fov?: number, near?: number, far?: number);
    static updateProjectionMatrix(cam: Camera): void;
    static updateViewMatrix(cam: Camera): void;
}
export declare class CameraSystem extends ComponentSystem {
    group: any[];
    depends: string[];
    onUpdate(): void;
}
